package com.sun.corba.se.impl.copyobject;

import com.sun.corba.se.impl.util.Utility;
import java.io.ObjectInputStream;
import java.io.ByteArrayInputStream;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.rmi.Remote;
import org.omg.CORBA.ORB;
import com.sun.corba.se.spi.copyobject.ObjectCopier;

public class JavaStreamObjectCopierImpl implements ObjectCopier
{
    private ORB orb;
    
    public JavaStreamObjectCopierImpl(ORB orb) {
        this.orb = orb;
    }
    
    public Object copy(Object obj) {
        if ((obj instanceof Remote)) {
            return Utility.autoConnect(obj, this.orb, true);
        }
        try {
            ByteArrayOutputStream out = new ByteArrayOutputStream(10000);
            new ObjectOutputStream(out).writeObject(obj);
            return new ObjectInputStream(new ByteArrayInputStream(out.toByteArray())).readObject();
        }
        catch (Exception obj2) {
            System.out.println("Failed with exception:" + obj2);
            return null;
        }
    }
}
